<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN"><HTML><HEAD><TITLE>80386 Programmer's Reference Manual -- Opcode NEG</TITLE> </HEAD><BODY><B>up:</B> <A HREF="c17.htm">Chapter 17 -- 80386 Instruction Set</A><BR><B>prev:</B><A HREF="MUL.htm"> MUL Unsigned Multiplication of AL or AX</A><BR><B>next:</B><A HREF="NOP.htm"> NOP No Operation</A><P><HR><P><H1>NEG -- Two's Complement Negation</H1><PRE>
Opcode  Instruction   Clocks    Description

F6  /3  NEG r/m8      2/6       Two's complement negate r/m byte
F7  /3  NEG r/m16     2/6       Two's complement negate r/m word
F7  /3  NEG r/m32     2/6       Two's complement negate r/m dword
</PRE><H2>Operation</H2><PRE>
IF r/m = 0 THEN CF := 0 ELSE CF := 1; FI;
r/m := - r/m;
</PRE><H2>Description</H2>NEG replaces the value of a register or memory operand with its two's complement. The operand is subtracted from zero, and the result is placed in the operand.<P>The carry flag is set to 1, unless the operand is zero, in which case the carry flag is cleared to 0.<H2>Flags Affected</H2>CF as described above; OF, SF, ZF, and PF as described in <A HREF="appc.htm">Appendix C</A><H2>Protected Mode Exceptions</H2>#GP(0) if the result is in a nonwritable segment; #GP(0) for an illegal memory operand effective address in the CS, DS, ES, FS, or GS segments; #SS(0) for an illegal address in the SS segment; #PF(fault-code) for a page fault<H2>Real Address Mode Exceptions</H2>Interrupt 13 if any part of the operand would lie outside of the effective address space from 0 to 0FFFFH<H2>Virtual 8086 Mode Exceptions</H2>Same exceptions as in real-address mode; #PF(fault-code) for a page fault<P><HR><P><B>up:</B> <A HREF="c17.htm">Chapter 17 -- 80386 Instruction Set</A><BR><B>prev:</B><A HREF="MUL.htm"> MUL Unsigned Multiplication of AL or AX</A><BR><B>next:</B><A HREF="NOP.htm"> NOP No Operation</A> </BODY>